package dev.shadowsoffire.apotheosis.ench.library;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile;
import dev.shadowsoffire.placebo.menu.BlockEntityMenu;
import dev.shadowsoffire.placebo.packets.ButtonClickMessage;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import java.util.List;
import net.minecraft.core.BlockPos;
import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.ForgeRegistry;

public class EnchLibraryContainer extends BlockEntityMenu<EnchLibraryTile> implements ButtonClickMessage.IButtonContainer {
  protected SimpleContainer ioInv = new SimpleContainer(3);
  
  protected Runnable notifier = null;
  
  public EnchLibraryContainer(int id, Inventory inv, BlockPos pos) {
    super((MenuType)Apoth.Menus.LIBRARY.get(), id, inv, pos);
    ((EnchLibraryTile)this.tile).addListener(this);
    initCommon(inv);
  }
  
  public void m_6877_(Player player) {
    super.m_6877_(player);
    if (!this.level.f_46443_)
      ((EnchLibraryTile)this.tile).removeListener(this); 
    m_150411_(player, (Container)this.ioInv);
  }
  
  void initCommon(Inventory inv) {
    m_38897_((Slot)new Object(this, (Container)this.ioInv, 0, 142, 77, inv));
    m_38897_((Slot)new Object(this, (Container)this.ioInv, 1, 142, 106));
    m_38897_((Slot)new Object(this, (Container)this.ioInv, 2, 142, 18));
    addPlayerSlots(inv, 8, 148);
    this.mover.registerRule((stack, slot) -> (slot.intValue() == 0), 3, 39);
    this.mover.registerRule((stack, slot) -> (slot.intValue() == 1), 3, 39);
    this.mover.registerRule((stack, slot) -> (slot.intValue() == 2), 3, 39);
    this.mover.registerRule((stack, slot) -> stack.m_150930_(Items.f_42690_), 0, 1);
    this.mover.registerRule((stack, slot) -> true, 2, 3);
    registerInvShuffleRules();
  }
  
  public boolean m_6875_(Player player) {
    return (player.m_20275_(this.pos.m_123341_(), this.pos.m_123342_(), this.pos.m_123343_()) < 256.0D && this.tile != null && !((EnchLibraryTile)this.tile).m_58901_());
  }
  
  public int getNumStoredEnchants() {
    return (int)((EnchLibraryTile)this.tile).getPointsMap().values().intStream().filter(s -> (s > 0)).count();
  }
  
  public List<Object2IntMap.Entry<Enchantment>> getPointsForDisplay() {
    return ((EnchLibraryTile)this.tile).getPointsMap().object2IntEntrySet().stream().filter(s -> (s.getIntValue() > 0)).toList();
  }
  
  public int getMaxLevel(Enchantment enchant) {
    return ((EnchLibraryTile)this.tile).getMax(enchant);
  }
  
  public int getPointCap() {
    return ((EnchLibraryTile)this.tile).maxPoints;
  }
  
  public void setNotifier(Runnable r) {
    this.notifier = r;
  }
  
  public void onChanged() {
    if (this.notifier != null)
      this.notifier.run(); 
  }
  
  public void onButtonClick(int id) {
    boolean shift = ((id & Integer.MIN_VALUE) == Integer.MIN_VALUE);
    if (shift)
      id &= Integer.MAX_VALUE; 
    Enchantment ench = (Enchantment)((ForgeRegistry)ForgeRegistries.ENCHANTMENTS).getValue(id);
    ItemStack outSlot = this.ioInv.m_8020_(1);
    int curLvl = ((Integer)EnchantmentHelper.m_44831_(outSlot).getOrDefault(ench, Integer.valueOf(0))).intValue();
    int targetLevel = shift ? Math.min(((EnchLibraryTile)this.tile).getMax(ench), 1 + (int)(Math.log((((EnchLibraryTile)this.tile).getPointsMap().getInt(ench) + EnchLibraryTile.levelToPoints(curLvl))) / Math.log(2.0D))) : (curLvl + 1);
    if (!((EnchLibraryTile)this.tile).canExtract(ench, targetLevel, curLvl))
      return; 
    if (outSlot.m_41619_())
      outSlot = new ItemStack((ItemLike)Items.f_42690_); 
    ((EnchLibraryTile)this.tile).extractEnchant(outSlot, ench, targetLevel);
    this.ioInv.m_6836_(1, outSlot);
  }
}
